package jp.ac.gifunct.ktajima.llservey;

import android.location.Location;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Created by ktajima on 2015/09/03.
 */
public class DataListElement {
    public static final int Column_Number = 0;
    public static final int Column_FolderName = 1;
    public static final int Column_FileName = 2;
    public static final int Column_Date = 3;
    public static final int Column_Time = 4;
    public static final int Column_Latitude = 5;
    public static final int Column_Longitude = 6;
    public static final int Column_Altitude = 7;
    public static final int Column_SubID = 8;
    public static final int Column_Size = 9;

    public static int counter = 0;

    private int Number;
    private String FolderName;
    private String FileName;
    private String DateString;
    private String TimeString;
    private double Latitude;
    private double Longitude;
    private double Altitude;
    private String SubID;


    private DataListElement(){};
    public static DataListElement parseFromLine(String Line){
        String[] elements = Line.split("\t");
        if(elements.length >= Column_Size){
            DataListElement element = new DataListElement();
            element.Number = Integer.parseInt(elements[Column_Number]);
            element.FolderName = elements[Column_FolderName];
            element.FileName = elements[Column_FileName];
            element.DateString = elements[Column_Date];
            element.TimeString = elements[Column_Time];
            element.Latitude = Double.parseDouble(elements[Column_Latitude]);
            element.Longitude = Double.parseDouble(elements[Column_Longitude]);
            element.Altitude = Double.parseDouble(elements[Column_Altitude]);
            element.SubID = elements[Column_SubID];
            return element;
        }
        return null;
    }

    public DataListElement(String folder,String file,Date date,Location location,String subid){
        this(counter++, folder, file,date,location,subid);
    }
    public DataListElement(int num,String folder,String file,Date date,Location location,String subid){
        this.Number = num;
        this.FolderName = folder;
        this.FileName = file;
        this.DateString = new SimpleDateFormat("yyyy-MM-dd").format(date);
        this.TimeString = new SimpleDateFormat("HH:mm:ss").format(date);
        this.Latitude = location.getLatitude();
        this.Longitude = location.getLongitude();
        this.Altitude = location.getAltitude();
        this.SubID = subid;
    }

    @Override
    public String toString() {
        StringBuilder buf = new StringBuilder();
        buf.append(this.Number);
        buf.append("\t");
        buf.append(this.FolderName);
        buf.append("\t");
        buf.append(this.FileName);
        buf.append("\t");
        buf.append(this.DateString);
        buf.append("\t");
        buf.append(this.TimeString);
        buf.append("\t");
        buf.append(this.Latitude);
        buf.append("\t");
        buf.append(this.Longitude);
        buf.append("\t");
        buf.append(this.Altitude);
        buf.append("\t");
        buf.append(this.SubID);
        return buf.toString();
    }

    public String toString(int count) {
        StringBuilder buf = new StringBuilder();
        buf.append(count);
        buf.append("\t");
        buf.append(this.FolderName);
        buf.append("\t");
        buf.append(this.FileName);
        buf.append("\t");
        buf.append(this.DateString);
        buf.append("\t");
        buf.append(this.TimeString);
        buf.append("\t");
        buf.append(this.Latitude);
        buf.append("\t");
        buf.append(this.Longitude);
        buf.append("\t");
        buf.append(this.Altitude);
        buf.append("\t");
        buf.append(this.SubID);
        return buf.toString();
    }
    public int getNumber() {
        return Number;
    }

    public String getFolderName() {
        return FolderName;
    }

    public String getFileName() {
        return FileName;
    }

    public String getDateString() {
        return DateString;
    }

    public String getTimeString() {
        return TimeString;
    }

    public double getLatitude() {
        return Latitude;
    }

    public double getLongitude() {
        return Longitude;
    }

    public double getAltitude() {
        return Altitude;
    }

    public String getSubID() {
        return SubID;
    }
}
