package jp.ac.gifunct.ktajima.llservey;

import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.v7.app.AppCompatActivity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

public class MainActivity extends AppCompatActivity {
    private Button takephotoButton;
    private Button confrimButton;
    private Button dataSendButton;
    private Button settingButton;

    private String SurveyName;

    public static final int ShootingActivityCalled = 1100;
    public static final int ConfirmActivityCalled = 1200;
    public static final int DataSendActivityCalled = 1300;
    public static final int SettingActivityCalled = 1400;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        this.takephotoButton = (Button)findViewById(R.id.PhotoButton);
        this.takephotoButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                MainActivity.this.PhotoButtonClicked(v);
            }
        });
        ((EditText)findViewById(R.id.editText_observername)).setFocusable(false);
        ((EditText)findViewById(R.id.editText_surveyname)).setFocusable(false);

        this.confrimButton = (Button)findViewById(R.id.confirmbutton);
        this.confrimButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                MainActivity.this.ConfirmButtonClicked(v);
            }
        });

        this.dataSendButton = (Button)findViewById(R.id.datasendbutton);
        this.dataSendButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                MainActivity.this.DataSendButtonClicked(v);
            }
        });

        this.settingButton = (Button)findViewById(R.id.settingbutton);
        this.settingButton.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                MainActivity.this.SettingClicked(v);
            }
        });

        // 前回の設定を復元
        SharedPreferences sp = PreferenceManager.getDefaultSharedPreferences(this);
        String observerName = sp.getString("observer", null);
        if(observerName != null){
            ((EditText)findViewById(R.id.editText_observername)).setText(observerName);
        }
        this.SurveyName = sp.getString(ToolsUtility.IntentKey_SurveyID, null);
        if(this.SurveyName != null) {
            ((EditText)findViewById(R.id.editText_surveyname)).setText(this.SurveyName);
            //調査を新規設定（または読み込み）
            ToolsUtility.startSurvey(this.SurveyName);
        }


    }

    private void PhotoButtonClicked(View v) {
        Intent intent = new Intent(MainActivity.this, shootingActivity.class);
        intent.putExtra(ToolsUtility.IntentKey_SurveyID,((EditText)findViewById(R.id.editText_surveyname)).getText().toString());
        startActivityForResult(intent, ShootingActivityCalled);
    }
    private void ConfirmButtonClicked(View v) {
        Intent intent = new Intent(MainActivity.this, ConfrimActivity.class);
        intent.putExtra(ToolsUtility.IntentKey_SurveyID,((EditText)findViewById(R.id.editText_surveyname)).getText().toString());
        startActivityForResult(intent, ConfirmActivityCalled);
    }
    private void DataSendButtonClicked(View v) {
        //Intent intent = new Intent(MainActivity.this, shootingActivity.class);
        //startActivity(intent);
    }
    private void SettingClicked(View v) {
        Intent intent = new Intent(MainActivity.this, SurveySettingActivity.class);
        intent.putExtra("observer",((EditText)findViewById(R.id.editText_observername)).getText().toString());
        intent.putExtra(ToolsUtility.IntentKey_SurveyID,((EditText)findViewById(R.id.editText_surveyname)).getText().toString());
        startActivityForResult(intent, SettingActivityCalled);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if( resultCode == Activity.RESULT_OK ){
            if(requestCode == ShootingActivityCalled) {
                //写真撮影が終わった場合
                //intentに継続（300）がある場合は再度撮影用のアクティビティを開く
                if(data.hasExtra("continue")){
                    this.PhotoButtonClicked(this.takephotoButton);
                }
            } else if(requestCode == SettingActivityCalled) {
                //設定が終わった場合
                if(data.hasExtra("observer")){
                    ((EditText)findViewById(R.id.editText_observername)).setText(data.getStringExtra("observer"));
                }
                if(data.hasExtra(ToolsUtility.IntentKey_SurveyID)){
                    this.SurveyName = data.getStringExtra(ToolsUtility.IntentKey_SurveyID);
                    ((EditText)findViewById(R.id.editText_surveyname)).setText(this.SurveyName);
                }
                //設定の保存
                // インスタンスを取得する
                SharedPreferences sp = PreferenceManager.getDefaultSharedPreferences(this);
                sp.edit().putString("observer", data.getStringExtra("observer")).commit();
                sp.edit().putString(ToolsUtility.IntentKey_SurveyID, this.SurveyName).commit();
                //調査を新規設定（または読み込み）
                ToolsUtility.startSurvey(this.SurveyName);

            }
        }
    }


}
