package jp.ac.gifunct.ktajima.llservey;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;


/**
 * Created by ktajima on 2015/09/03.
 */
public class SettingXMLParser {
    private ArrayList<String> surveyNameList;
    private HashMap<String,SurveyData> dataMap;

    public SettingXMLParser(){
        this.dataMap = new HashMap<String,SurveyData>();
        this.surveyNameList = new ArrayList<String>();
    }

    public ArrayList<String> getSurveyNameList() {
        return surveyNameList;
    }

    public HashMap<String, SurveyData> getDataMap() {
        return dataMap;
    }

    /** XMLファイルを開く　１行の最大文字数を返す */
    public void openXMLFile(File ofile) throws IOException, ParserConfigurationException, SAXException{
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = factory.newDocumentBuilder();
        Document doc = builder.parse(ofile);
        Element root = doc.getDocumentElement();
        NodeList children = root.getChildNodes();

        String currentServeyName = "";
        HashMap<String,ArrayList<String>> tagdata = new HashMap<String,ArrayList<String>>();
        String title = "";
        String memo = "";
        int currentLine = -1;
        for( int i=0; i<children.getLength(); i++ ) {
            Node child = children.item(i);
            if( child instanceof Element ) {
                Element charElement = (Element) child;
                if(charElement.getTagName().equals("survey")) {
                    //survey要素を見つけた場合値を初期化
                    currentServeyName = "";
                    tagdata = new HashMap<String,ArrayList<String>>();
                    title = "";
                    memo = "";

                    //子要素を調べる
                    NodeList dataList = charElement.getChildNodes();
                    for (int j = 0; j < dataList.getLength(); j++) {
                        Node dataNode = dataList.item(j);
                        if (dataNode instanceof Element) {
                            if (((Element) dataNode).getTagName().endsWith("name")) {
                                //文字データを取り出す
                                Node textNode = dataNode.getFirstChild();
                                currentServeyName = textNode.getNodeValue();
                            } else if (((Element) dataNode).getTagName().endsWith("tag")) {
                                //Tagデータを取り出す
                                String key = "";
                                ArrayList<String> values = new ArrayList<String>();
                                NodeList tagNodes = dataNode.getChildNodes();
                                for (int l = 0; l < tagNodes.getLength(); l++) {
                                    Node lnode = tagNodes.item(l);
                                    if (lnode instanceof Element) {
                                        if (((Element) lnode).getTagName().endsWith("key")) {
                                            if(lnode.getFirstChild() != null) {
                                                key = lnode.getFirstChild().getNodeValue();
                                            }
                                        } else if (((Element) lnode).getTagName().endsWith("value")) {
                                            if(lnode.getFirstChild() != null) {
                                                values.add(lnode.getFirstChild().getNodeValue());
                                            }
                                        }
                                    }
                                }
                                //タグ情報に追加
                                tagdata.put(key, values);

                            } else if (((Element) dataNode).getTagName().endsWith("title")) {
                                Node textNode = dataNode.getFirstChild();
                                if(textNode != null)
                                    title = textNode.getNodeValue();
                            } else if (((Element) dataNode).getTagName().endsWith("memo")) {
                                Node textNode = dataNode.getFirstChild();
                                if(textNode != null)
                                    memo = textNode.getNodeValue();
                            }
                        }
                    }
                    //survey要素のNode処理がすべて終わったらデータ化する
                    SurveyData data = new SurveyData(currentServeyName,tagdata,title,memo);
                    this.surveyNameList.add(currentServeyName);
                    this.dataMap.put(currentServeyName,data);
                }
            }
        }
    }



}



